searchNodes=[{"doc":"Module to work with a Docker environment for testing.Compox starts Docker containers when the application starts (see configuration for more info).Containers availabilityCompox makes two checks to ensure the containers are available:the container has running status.the exposed ports to the host, if any, accept connections.Configurationauto_start: Whether the docker compose services should start with this application. Defaults to true.auto_stop: Whether the docker compose services should stop after the tests. Defaults to true.exclude: The list of Docker services to exclude. These services won't be started by Compox.container_upchecks: Keyword list of functions that will be used to check if a container an up state. See Compox.Docker.Containers documentation for more info.kill_on_finish: Kills the containers instead of stopping them.Container upchecksThere are containers that need more checks rather than just accepting connection on a port. In those cases, you can use container_upchecks config and provide a function that will be reevaluated until it returns :ok.Example: checking Postgres connectionIf you use a PostgreSQL containers, you will need to ensure that ecto will be able to connect to the container before running the tests. In the following example, we will be using Postgrex.Protocol.connect/1 to attempt a connection to the database. The upcheck function will check whether the Postgres connection returned an application (invalid credentials, unknown catalog...) or a connection error.","ref":"Compox.html","title":"Compox","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Compox.html#child_spec/1","title":"Compox.child_spec/1","type":"function"},{"doc":"Stops all the started containers.Any container started using the docker-compose.yml will be stopped.","ref":"Compox.html#stop/0","title":"Compox.stop/0","type":"function"},{"doc":"Module that provides functions to interact with Docker and docker-compose files.","ref":"Compox.Docker.Compose.html","title":"Compox.Docker.Compose","type":"module"},{"doc":"Start services listed on the docker-compose.yml file.","ref":"Compox.Docker.Compose.html#up/1","title":"Compox.Docker.Compose.up/1","type":"function"},{"doc":"Provides functions to work with Compox services.","ref":"Compox.Docker.Services.html","title":"Compox.Docker.Services","type":"module"},{"doc":"Starts services from the docker compose.Each service is started independently.After all services are launch, returns the list of services updated with each container id.","ref":"Compox.Docker.Services.html#start/1","title":"Compox.Docker.Services.start/1","type":"function"},{"doc":"Stops the given services.In order to stop the containers, sends a SIGKILL message to all the container process.","ref":"Compox.Docker.Services.html#stop/1","title":"Compox.Docker.Services.stop/1","type":"function"},{"doc":"Represents a Docker service.","ref":"Compox.Docker.Services.Service.html","title":"Compox.Docker.Services.Service","type":"module"},{"doc":"A internal representation of a Docker service present in a docker-compose file:name: The name of the Docker service.image: The Docker image used by the service.container_id: The id of the Docker container.container_name: The name of the service container, defaults to nil.reused: Whether the container running this service was already created or running.","ref":"Compox.Docker.Services.Service.html#t:t/0","title":"Compox.Docker.Services.Service.t/0","type":"type"},{"doc":"","ref":"Mix.Tasks.Compox.Down.html","title":"Mix.Tasks.Compox.Down","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Compox.Down.html#run/1","title":"Mix.Tasks.Compox.Down.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Compox.Up.html","title":"Mix.Tasks.Compox.Up","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Compox.Up.html#run/1","title":"Mix.Tasks.Compox.Up.run/1","type":"function"},{"doc":"CompoxCompox starts Docker containers on demand.Compox helps you to setup an ephemeral environment to run your tests using the docker-compose.yml present in your project. After all your tests are done, it will take the test environment down. This way your machine won't waste resources having the containers running when they are not needed.","ref":"readme.html","title":"Compox","type":"extras"},{"doc":"This project is still in beta status and therefore you might find issues using it. In any case, a ticket on this project is more than welcome to fix anything broken/to improve.","ref":"readme.html#disclaimer","title":"Compox - DISCLAIMER","type":"extras"},{"doc":"Adding compox to your list of dependencies in mix.exs:def deps do [ {:compox, &quot;~&gt; 0.1.0-beta6&quot;, only: [:test]} ] end","ref":"readme.html#installation","title":"Compox - Installation","type":"extras"},{"doc":"To use Compox follow these steps:Create a docker-compose.yml file with the containers that will be started by this application.Ensure Compox starts all containers before running the tests:defp aliases do [ test: [&quot;compox.up&quot;, &quot;ecto.create --quiet&quot;, &quot;ecto.migrate --quiet&quot;, &quot;test&quot;] ] endEdit your test_helper.exs to stop the containers after the tests are done:ExUnit.after_suite(fn _ -&gt; Compox.stop() end)ExampleCompox allows you to configure a project to start/stop the containers to run the tests, but also provides configuration to work with any kind of situation.For example, some of or coworkers prefer to have the containers running all the time. In this case you want to ensure the docker containers are started before the test, so people that prefer to save resources will start the containers, but you will also won't to avoid to take containers down.You config/test.exs file will look like:use Mix.Config config :compox, auto_start: true, auto_stop: false, # Ensure Postgrex can connect to the db and throws an postgres error (catalog # unknown, invalid credentials...) container_upchecks: [ &quot;postgres-graphql&quot;: fn -&gt; Postgrex.Protocol.connect( hostname: &quot;localhost&quot;, database: &quot;&quot;, username: &quot;&quot;, types: nil ) |&gt; case do {:error, %{postgres: _}} -&gt; :ok _ -&gt; :error end end ]The people who will want to stop the containers after test can use a dotenv library to change the auto_stop config to true on their machines.This can work the other way around, start/stopping the containers always and having dotfile config to skipping the start/stop.","ref":"readme.html#usage","title":"Compox - Usage","type":"extras"}]